<?php

ini_set('max_execution_time', 300);

//ini_set("display_errors", "on");
use Google\Spreadsheet\DefaultServiceRequest;
use Google\Spreadsheet\ServiceRequestFactory;

class GeneratedReorder extends MY_Controller {

    public function index() {

        $all_fields_ = array("ID", "SKU", "LastSuppliedBy", "DaysInStock", "Sales", "Velocity", "OnHand", "Allocated", "OnOrder", "MinimumBeforeReorder", "ReorderQuantity", "NoStockinXDays", "MOQ", "PcsPerCarton", "LeadTime", "DaystoStock", "ReorderinXDays", "ToOrder", "AmounttoOrder", "ReOrderDue", "CustomOrderAmount", "ReOrder", "AutoReOrder");
        $all_fields = array();
        foreach ($all_fields_ as $value) {
            $all_fields[$value] = $value;
        }
        $list1 = $this->setting_field_model->ReadVisibleFieldForTableAssoc($this->table_name);
        $counter = 0;
        foreach ($all_fields as $f) {
            if (!in_array($f, $list1)) {
                unset($all_fields[$f]);
            }
            $counter++;
        }
        $this->map("fields", $all_fields);

        $this->map("cols", $this->generated_reorder_model->Cols());
        $table_name = "gs_generated_reorder";
        $this->map("list_fields", $this->setting_field_model->ReadForTable($table_name));
        $dt = $this->last_update_model->LastDt($_SESSION['userinfo']['email'], 'generated_reorder');
        $this->map("dt", $dt);
        /*         * ************************************************************* */
        $opers = $this->session->userdata("opers");
        if (!$opers) {
            $opers = array();
        }
        if (count($opers) > 0) {
            $s = "";
            foreach ($opers as $k => $v) {
                $s = $s . " and (" . $this->getClause($v['field'], $v['oper'], $v['val']) . ")";
            }
        }
        $q = "select * from gs_generated_reorder where _dt = ( select max(_dt) from gs_generated_reorder  )  " . $s;
        $list = $this->db->query($q)->result();
        //###########################################
        $list_manudal_product_data = $this->manual_product_data_model->ReadAssocBySku();
        $olist = array();
        foreach ($list as $evalue) {
            if (
                    isset($list_manudal_product_data[$evalue->SKU]) &&
                    isset($list_manudal_product_data[$evalue->SKU]->daysinstock)
            ) {
                $evalue->DaysInStock = $evalue->DaysInStock + $list_manudal_product_data[$evalue->SKU]->daysinstock;
            }
            if (
                    isset($list_manudal_product_data[$evalue->SKU]) &&
                    isset($list_manudal_product_data[$evalue->SKU]->sales)
            ) {
                $evalue->Sales = $evalue->Sales + $list_manudal_product_data[$evalue->SKU]->sales;
            }

            $olist[$evalue->SKU] = $evalue;
        }
        //############################################
        $this->map("list", $olist);
        $this->map("opers", $opers);
        $this->render($this->header());
        $this->render("layout/global_header");
        $this->render();
        $this->render("layout/global_footer");
        $this->render($this->footer());
    }

    public function resetAllUnSelect() {
        $this->generated_reorder_model->SetAllUnChecktoFalse();
        echo json_encode(array("status" => "success"));
    }

    public function clearAllFilters() {

        $this->session->unset_userdata('opers');
        redirect("generatedReorder/index");
    }

    public function startsWith($haystack, $needle) {
        // search backwards starting from haystack length characters from the end
        return $needle === "" || strrpos($haystack, $needle, -strlen($haystack)) !== FALSE;
    }

    function ajaxFetch() {
        $field = $this->input->get("field");
        $oper = $this->input->get("oper");
        $val = $this->input->get("val");
        $opers = $this->session->userdata("opers");
        if (!$opers) {
            $opers = array();
        }
        $s1 = "";
        if ($oper == "remove") {
            /*             * *************Remove******************** */
            foreach ($opers as $k => $v) {
                $s1 = $s1 . "/" . $k;
                if ($field != "ToOrder" && $field != "ReorderinXDays") {
                    unset($opers[$v['field']]);
                    break;
                }

                if ($field == "ToOrder" || $field == "ReorderinXDays") {
                    unset($opers[$v['field'] . $v['oper']]);
                    break;
                }
            }
            /*             * *************Remove End******************** */
        } else {
            if ($field == "ReorderinXDays" || $field == "ToOrder") {
                $opers[$field . $oper] = array("field" => $field, "oper" => $oper, "val" => $val);
            } else {
                $opers[$field] = array("field" => $field, "oper" => $oper, "val" => $val);
            }
        }
        $this->session->set_userdata("opers", $opers);
        $s = "";
        if (count($opers) > 0) {
            $s = "";
            foreach ($opers as $k => $v) {
                $s = $s . " and (" . $this->getClause($v['field'], $v['oper'], $v['val']) . ")";
            }
        }
        $q = "select * from gs_generated_reorder where _dt = ( select max(_dt) from gs_generated_reorder  )  " . $s;
        $list = $this->db->query($q)->result();

        echo json_encode(array("message" => "success", "opers" => $opers, "list" => $list, "q" => $q, "s" => $s1, "field" => $field));
    }

    public function success() {
        $this->render($this->header());
        $this->render("layout/global_header");
        $this->render();
        $this->render("layout/global_footer");
        $this->render($this->footer());
    }

    public function placeReorder() {
        $IDs = $this->input->get("IDs");
        $list_item = $this->generated_reorder_model->ReadLatestMultipleGroupBySupplier(substr($IDs, 0, strlen($IDs) - 1));
        $this->map("list_item", $list_item);

        $this->map("fields", $this->setting_field_model->ReadVisibleFieldForTable($this->table_name));
        $this->map("cols", $this->generated_reorder_model->Cols());

        /*         * ******************************************** */
        $opers = $this->session->userdata("opers");
        if (!$opers) {
            $opers = array();
        }
        /*         * ************************************************************* */
        if (count($opers) > 0) {

            $s = "";
            foreach ($opers as $k => $v) {
                $s = $s . " and (" . $this->getClauseSupplier($v['field'], $v['oper'], $v['val']) . ")";
            }
        }
        $q = "select * from gs_manual_supplier_data where ( 1 = 1) " . $s;
        //  echo $q;
        $list_supplier = $this->db->query($q)->result();
        $this->map("list_supplier", $list_supplier);
        $this->map("opers", $opers);

        //$list_supplier = $this->manual_supplier_data_model->ReadAssocBySupplier();
        //$this->map("list_supplier", $list_supplier);
        /*         * ******************************************** */

        $this->render($this->header());
        $this->render("layout/global_header");
        $this->render();
        $this->render("layout/global_footer");

        $this->render($this->footer());
    }

    public function placeReorder_() {
        $IDs = $this->input->get("IDs");
        $list = $this->generated_reorder_model->ReadLatestMultipleGroupBySupplier(substr($IDs, 0, strlen($IDs) - 1));
        $this->map("list", $list);
        $this->map("fields", $this->setting_field_model->ReadVisibleFieldForTable($this->table_name));
        $this->map("cols", $this->generated_reorder_model->Cols());
        $this->render($this->header());
        $this->render("layout/global_header");
        $this->render();
        $this->render("layout/global_footer");

        $this->render($this->footer());
    }

    public function clearAllOrdersAndGenerate() {
        $SKUs = $this->input->get("SKUs");
        $SKUs = substr($SKUs, 0, strlen($SKUs) - 1);
        $all_manual_products = $this->manual_product_data_model->ReadAssocBySku();
        $all_generated_reorders = $this->generated_reorder_model->ReadAssocByLastSuppliedByAndSku();
        $SKU_LIST = explode(",", $SKUs);
        //-----------------------------------------------------------
        foreach ($all_generated_reorders as $LastSuppliedBy => $array) {
            $sheet_name_1 = $LastSuppliedBy . "_po_" . date("Y") . "_" . date("m") . "_" . date("d") . "_" . date("h") . "_" . date("i") . "_" . date("s");
            $worksheet_1 = $this->currentSpreadSheetNew->addWorksheet($sheet_name_1, 50, 20);
            $cellFeed_1 = $worksheet_1->getCellFeed();
            $listFeed_1 = $worksheet_1->getListFeed();

            $sheet_name_2 = $LastSuppliedBy . "_notes_" . date("Y") . "_" . date("m") . "_" . date("d") . "_" . date("h") . "_" . date("i") . "_" . date("s");
            $worksheet_2 = $this->currentSpreadSheetNew->addWorksheet($sheet_name_2, 50, 20);
            $cellFeed_2 = $worksheet_2->getCellFeed();
            $listFeed_2 = $worksheet_2->getListFeed();

            $columns = array("SKU", "SupplierProductCode", "SupplierProductName", "Quantity", "SupplierFixedPrice", "Total", "Cartons", "Carton Weight", "Carton Height", "Carton Width", "Carton Depth", "CBM");
            $columns2 = array("sku", "supplierproductcode", "barcode", "notesproduct",
                "notespackaging",
                "notescartons",
                "notesmarks",
                "notesqc",
                "notesbrand");
            foreach ($columns as $key => $column) {
                $cellFeed_1->editCell(1, $key + 1, $column);
            }
            foreach ($columns2 as $key => $column) {
                $cellFeed_2->editCell(1, $key + 1, $column);
            }

            $master = new Purchase_order_master_model();
            $master->OrderReference = "";
            $master->OrderType = "";
            $master->Supplier = $LastSuppliedBy;
            $master->TotalCBM = 0;
            $master->TotalCartons = 0;
            $master->TotalTotal = 0;
            $master->dt = date("Y-m-d");
            $master->status = "active";
            $master->title = $sheet_name_1;
            $this->purchase_order_master_model->Create($master);
            //-----------------------------------------------------------        
            foreach ($SKU_LIST as $SKU) {
                $mpd = $all_manual_products[$SKU];
                $gen_reorder = $array[$SKU];
                if ($gen_reorder->SKU == $mpd->sku) {
                    $detail = new Purchase_order_detail_model();
                    $detail->purchase_order_master_id = $master->_id;
                    $detail->SKU = $SKU;
                    $detail->SupplierProductCode = $mpd->supplierproductcode;
                    $detail->SupplierProductName = $mpd->supplierproductname;
                    $detail->SupplierFixedPrice = $mpd->supplierfixedprice;
                    $detail->CBM = 0;
                    $detail->CartonDepth = $mpd ? $mpd->cartondepth : null;
                    $detail->CartonHeight = $mpd ? $mpd->cartonheight : null;
                    $detail->CartonWeight = $mpd ? $mpd->cartonweight : null;
                    $detail->CartonWidth = $mpd ? $mpd->cartonwidth : null;
                    $detail->Quantity = $gen_reorder->_custom_checkbox === "yes" ?
                            $gen_reorder->CustomOrderAmount :
                            $gen_reorder->ReorderQuantity;
                    $detail->Cartons = $this->CartonCount($detail->Quantity, $mpd->pcspercarton);
                    $detail->Total = $detail->Quantity * $detail->SupplierFixedPrice;

                    $row = array("sku" => $SKU,
                        "supplierproductcode" => $mpd->supplierproductcode,
                        "supplierproductname" => $mpd->supplierproductname,
                        "quantity" => $gen_reorder->_custom_checkbox === "yes" ?
                                $gen_reorder->CustomOrderAmount :
                                $gen_reorder->ReorderQuantity,
                        "supplierfixedprice" => $mpd->supplierfixedprice,
                        "total" => $gen_reorder->_custom_checkbox === "yes" ?
                                ($mpd->supplierfixedprice * $gen_reorder->CustomOrderAmount) :
                                ($mpd->supplierfixedprice * $gen_reorder->ReorderQuantity),
                        "cartons" => $this->CartonCount($detail->Quantity, $mpd->pcspercarton),
                        "cartonweight" => $mpd ? $mpd->cartonweight : null,
                        "cartonheight" => $mpd ? $mpd->cartonheight : null,
                        "cartonwidth" => $mpd ? $mpd->cartonwidth : null,
                        "cartondepth" => $mpd ? $mpd->cartondepth : null,
                        "cbm" => 0);
                    $row2 = array("sku" => $SKU,
                        "supplierproductcode" => $mpd->supplierproductcode,
                        "barcode" => $mpd->barcode,
                        "notesproduct" => $mpd->notesproduct,
                        "notespackaging" => $mpd->notespackaging,
                        "notescartons" => $mpd->notescartons,
                        "notesmarks" => $mpd->notesmarks,
                        "notesqc" => $mpd->notesqc,
                        "notesbrand" => $mpd->notesbrand);

                    $listFeed_1->insert($row);
                    $listFeed_2->insert($row2);
                    $this->purchase_order_detail_model->Create($detail);
                    $http_status = "";
                    //    $this->dear_product->updateReorderQuantity($gen_reorder->ID, $gen_reorder->ReorderQuantity, $http_status);
                }
            }
        }
        $this->generated_reorder_model->ClearAllOrders($SKUs);



        /*
         *  To be implemented :Generate Purchase Order and Product Notes
         */
        echo json_encode(array("message" => "Success"));
    }

    public function CartonCount($Quantity, $PcsPerCarton) {
        if ($Quantity <= 0)
            return 0;
        $Quantity = $Quantity - 1;
        return (int) ($Quantity / $PcsPerCarton) + 1;
    }

    public function UpdateCustomOrderAmount() {
        $http_status = "";
        $ID = $this->input->get("ID");
        $row = $this->generated_reorder_model->FindByID($ID);

        $CustomOrderAmount = $this->input->get("CustomOrderAmount");
        if (!is_numeric($CustomOrderAmount)) {
            $CustomOrderAmount = 0;
        }
        $this->generated_reorder_model->UpdateCustomOrderAmount($CustomOrderAmount, $ID);
        $row = $this->generated_reorder_model->FindByID($ID);

        //if reorder is checked then p
        if ($row->ReOrder == "yes") {
            $response = $this->dear_product->updateReorderQuantity($ID, $CustomOrderAmount, $http_status);
        } else {
            $response = "";
        }
        echo json_encode(
                array(
                    "message" => "success",
                    "ReorderQuantity" => $row->ReorderQuantity,
                    "CustomOrderAmount" => $row->CustomOrderAmount,
                    //"response" => $response,
                    "row" => $row
        ));
    }

    public function DeleteCustomOrderAmount() {
        $ID = $this->input->get("ID");
        $row = $this->generated_reorder_model->FindByID($ID);
        $row->CustomOrderAmount = null;
        $row->_custom_checkbox = "no";
//  1A.Reorder is Check, copy system generated original value to Reorder Qty as general logic.
        if ($row->ReOrder == "yes") {
            $row->ReorderQuantity = $row->AmounttoOrder;
        } else {
            //1B.Reorder is not checked, show "-" in Reorder Qty with value NULL. and show checkbox only without checked.
            $row->ReorderQuantity = null;
            $row->CustomOrderAmount = null;
        }
        $this->generated_reorder_model->Update($row);
        $row = $this->generated_reorder_model->FindByID($ID);
        echo json_encode(
                array(
                    "message" => "success",
                    "row" => $row
        ));
    }

    public function UpdateCustomOrderAmountNo() {
        $ID = $this->input->get("ID");
        $CustomOrderAmount = $this->input->get("CustomOrderAmount");
        $this->generated_reorder_model->UpdateCustomOrderAmountNo($CustomOrderAmount, $ID);

        $row = $this->generated_reorder_model->FindByID($ID);
        /*         * ********************************************* */
        $ReorderQuantity = 0;
        if ($row->ReOrder == "yes") {
            if ($row->_custom_checkbox == "yes") {
                $ReorderQuantity = $row->CustomOrderAmount;
            } else {
                $ReorderQuantity = $row->AmounttoOrder;
            }
        } else {
            $ReorderQuantity = "-";
        }
        /*         * ******************************************** */
        echo json_encode(array("message" => "success",
            "ReorderQuantity" => $ReorderQuantity,
            "CustomOrderAmount" => $row->CustomOrderAmount));
    }

    /*
      b) If the “ReOrder checkbox” is selected, then edit the “MinimumBeforeReorder”
      field to equal the value from the “On Hand” field. */

    public function updateMinimumBeforeReorderToOnHand() {

        try {
            $_id = $this->input->get("_id");
            $reorder = $this->input->get("reorder");
            $row = $this->generated_reorder_model->Find($_id);
            if ($reorder == "yes") {
                $row->MinimumBeforeReorder = $row->OnHand;
            } else {
                //$mpd = $this->manual_product_data_model->FindBysku($row->SKU);
                //$row->MinimumBeforeReorder = isset($mpd->manualminimumbeforereorder) ? $mpd->manualminimumbeforereorder : 0;
            }
            $row->ReOrder = $reorder;
            $row->_uncheck = $reorder == "yes" ? "false" : "true";
            $this->generated_reorder_model->Update($row);
            $this->generated_reorder_model->updateConditionalSingle($row->ID);
            $row = $this->generated_reorder_model->Find($_id);
            $http_status = "";
            if ($reorder == "yes") {
                //   $response = $this->dear_product->updateMinimumBeforeReorder($row->ID, $row->MinimumBeforeReorder, $http_status);
                $response = $this->dear_product->updateMinimumBeforeReorderAndReorderQuantity(
                        $row->ID, $row->MinimumBeforeReorder, isset($row->CustomOrderAmount) && trim($row->CustomOrderAmount) != "" ? $row->CustomOrderAmount : $row->ReorderQuantity
                        , $http_status);
            }
            echo json_encode(
                    array(
                        "message" => "success",
                        "MinimumBeforeReorder" => $row->MinimumBeforeReorder,
                        "ReorderQuantity" => $row->ReorderQuantity,
                        "response" => $response
                    )
            );
        } catch (Exception $ex) {
            print_r($ex);
        }
    }

    public function updateReorder() {
        $IDs = $this->input->get("IDs");
        $IDs = substr($IDs, 0, strlen($IDs) - 1);
        $ID_ARRAY = explode(",", $IDs);
        $this->session->unset_userdata('opers');
        $this->generated_reorder_model->ResetReorder($ID_ARRAY);
        echo json_encode(array("message" => "success"));
    }

    public function saveReorder() {
        $IDs = $this->input->get("IDs");
        $IDs = substr($IDs, 0, strlen($IDs) - 1);
        $ID_ARRAY = explode(",", $IDs);
        $outlist = array();
        foreach ($ID_ARRAY as $value) {
            $outlist[] = "'" . $value . "'";
        }
        $this->generated_reorder_model->ResetReorder($ID_ARRAY);
        $this->generated_reorder_model->updateConditional(implode(",", $outlist));
        echo json_encode(array("message" => "success"));
    }

    function ajaxFetchReOrder() {
        $field = $this->input->get("field");
        $oper = $this->input->get("oper");
        $val = $this->input->get("val");
        $opers = $this->session->userdata("opers");
        if (!$opers) {
            $opers = array();
        }
        if ($oper == "remove") {
            unset($opers[$field]);
        } else {
            $opers[$field] = array("field" => $field, "oper" => $oper, "val" => $val);
        }
        $this->session->set_userdata("opers", $opers);
        //  $s = "";
        //  if (count($opers) > 0) {
        //      $s = "";
        //     foreach ($opers as $k => $v) {
        //         $s = $s . " and (" . $this->getClause($v['field'], $v['oper'], $v['val']) . ")";
        // //    }
        //  }
        //  $q = "select * from gs_generated_reorder where ReOrder='yes' and  _dt = ( select max(_dt) from gs_generated_reorder  )  " . $s;
        //  $list = $this->db->query($q)->result();
        //echo json_encode(array("message" => "success", "opers" => $opers, "list" => $list, "q" => $q));

        echo json_encode(array("message" => "success", "opers" => $opers));
    }

    public function updateAutoReOrder() {
        $AutoReOrder = $this->input->get("AutoReOrder");
        $id = $this->input->get("id");
        $row = $this->generated_reorder_model->Find($id);
        $row->AutoReOrder = $AutoReOrder;
        $this->generated_reorder_model->Update($row);
        echo json_encode(array("message" => "success"));
    }

    public function refresh() {
        $this->cron_util->GeneratedReorder_refresh();
        redirect("generatedReorder/index");
    }

    public function syncToDear() {
        $response = array();
        $list = $this->generated_reorder_model->Read();
        foreach ($list as $value) {
            $http_status = "";
            $this->dear_product->updateMinimumBeforeReorderAndReorderQuantity($value->ID, $value->MinimumBeforeReorder, $value->ReorderQuantity, $http_status);
            $response[] = array("ID" => $value->ID, "http_status" => $http_status);
        }
        echo json_encode($response);
    }

    public function castField($field) {
        $fields = array(
            "ID" => "string",
            "SKU" => "string",
            "LastSuppliedBy" => "string",
            "DaysInStock" => "numeric",
            "Sales" => "numeric",
            "Velocity" => "numeric",
            "OnHand" => "numeric",
            "Allocated" => "numeric",
            "OnOrder" => "numeric",
            "MinimumBeforeReorder" => "numeric",
            "ReorderQuantity" => "numeric",
            "NoStockinXDays" => "numeric",
            "MOQ" => "numeric",
            "PcsPerCarton" => "numeric",
            "LeadTime" => "numeric",
            "DaystoStock" => "numeric",
            "ReorderinXDays" => "numeric",
            "ToOrder" => "numeric",
            "AmounttoOrder" => "numeric",
            "ReOrderDue" => "string",
            "CustomOrderAmount" => "numeric",
            "ReOrder" => "string",
            "AutoReOrder" => "string",
            "_supplier_code" => "string",
            "_supplier_type" => "string",
            "_supplier_port" => "string");
        return $fields[$field] == "string" ? $field : " CAST($field AS DECIMAL(10,6)) ";
    }

    public function castFieldSupplier($field) {
        $fields = array(
            "supplier" => "string",
            "suppliercode" => "string",
            "suppliertype" => "string",
            "port" => "string");
        return $fields[$field] == "string" ? $field : " CAST($field AS DECIMAL(10,6)) ";
    }

    public function getClause($field, $oper, $val) {
        if ($oper == "begins with") {
            return $this->castField($field) . " like '" . $val . "%'";
        }
        if ($oper == "ends up") {
            return $this->castField($field) . " like '%" . $val . "'";
        }
        if ($oper == "contains") {
            return $this->castField($field) . " like '%" . $val . "%'";
        }
        if ($oper == "greater than") {
            return $this->castField($field) . " > '" . $val . "'";
        }
        if ($oper == "less than") {
            return $this->castField($field) . " < '" . $val . "'";
        }
        if ($oper == "equals") {
            return $this->castField($field) . " = '" . $val . "'";
        }
        return "";
    }

    public function getClauseSupplier($field, $oper, $val) {
        if ($oper == "begins with") {
            return $this->castFieldSupplier($field) . " like '" . $val . "%'";
        }
        if ($oper == "ends up") {
            return $this->castFieldSupplier($field) . " like '%" . $val . "'";
        }
        if ($oper == "contains") {
            return $this->castFieldSupplier($field) . " like '%" . $val . "%'";
        }
        if ($oper == "greater than") {
            return $this->castFieldSupplier($field) . " > '" . $val . "'";
        }
        if ($oper == "less than") {
            return $this->castFieldSupplier($field) . " < '" . $val . "'";
        }
        if ($oper == "equals") {
            return $this->castFieldSupplier($field) . " = '" . $val . "'";
        }
        return "";
    }

    /*     * *************************************************************************** */

    public function __construct() {
        parent::__construct();
        try {
            $this->google_client = new Google_Client();
            $this->google_client->setClientId($this->google_sheet->ClientID());
            $this->google_client->setClientSecret($this->google_sheet->ClientSecret());
            $this->google_client->setRedirectUri($this->google_sheet->RedirectURI());
            $this->google_client->setScopes(array('https://spreadsheets.google.com/feeds'));
            //https://developers.google.com/identity/protocols/OAuth2WebServer?hl=en
            $this->google_client->setAccessType("offline");
            if (isset($_SESSION['token'])) { // extract token from session and configure client
                $this->google_client->setAccessToken($_SESSION['token']);
            }
            if (!$this->google_client->getAccessToken()) {
                redirect("welcome/index");
            }

            $this->accessToken = json_decode($this->google_client->getAccessToken());

            $this->serviceRequest = new DefaultServiceRequest($this->accessToken->access_token);
            ServiceRequestFactory::setInstance($this->serviceRequest);
            $this->spreadsheetService = new Google\Spreadsheet\SpreadsheetService();
            $this->spreadsheetFeed = $this->spreadsheetService->getSpreadsheets();
            $this->currentSpreadSheet = $this->spreadsheetFeed->getByTitle("Inventory ReOrder Database");
            $this->worksheetFeed = $this->currentSpreadSheet->getWorksheets();
            $this->currentSpreadSheetNew = $this->spreadsheetFeed->getByTitle($this->sheetName);
            if ($this->currentSpreadSheetNew) {
                $this->worksheetFeedNew = $this->currentSpreadSheetNew->getWorksheets();
            }
        } catch (Exception $ex) {
            $this->session->sess_destroy();
            redirect("welcome/index");
        }
        //print_r($this->worksheetFeed);
    }

    public $sheetName = "swampsheet";
    public $google_client;
    public $accessToken;
    public $serviceRequest;
    public $spreadsheetService;
    public $spreadsheetFeed;
    public $currentSpreadSheet;
    public $worksheetFeed;
    public $currentSpreadSheetNew;
    public $worksheetFeedNew;
    public $table_name = "gs_generated_reorder";

    /*     * ************************************************************************* */
}
