<?php
//https://docs.google.com/spreadsheets/d/1KgKUov-qTGathXosMaP0pARbZB9_NiwncCCo5im7-tk/pub?output=csv
//http://stackoverflow.com/questions/14780804/how-do-i-read-a-google-drive-spreadsheet-in-php
//http://www.farinspace.com/saving-form-data-to-google-spreadsheets/
//http://www.computerworld.com/article/2469616/business-intelligence/business-intelligence-79661-how-to-create-an-automatically-updating-spreadsheet.html#slide6
//ini_set("display_errors", "on");
use Google\Spreadsheet\DefaultServiceRequest;
use Google\Spreadsheet\ServiceRequestFactory;

class Netosync extends MY_Controller {

    public function index() {
        $data = array(
            "list_loc" => $this->Neto_google_location_model->Read(),
            "list_label" => $this->Neto_google_sku_custom_label_model->Read()
        );
    }
    
      
  

    public function sync() {
        try {
            $worksheet_location = $this->worksheetFeed->getByTitle('Data');
            $listFeed_location = $worksheet_location->getListFeed();
            $entries_location = $listFeed_location->getEntries();
            $worksheet_custom_label = $this->worksheetFeed2->getByTitle('Sheet1');
            $listFeed_custom_label = $worksheet_custom_label->getListFeed();
            $entries_custom_label = $listFeed_custom_label->getEntries();

            /*             * ***************************************************************** */
            for ($i = 0; $i < count($entries_location); $i++) {
                $entry_location = $entries_location[$i];
                $value_location = $entry_location->getValues();

                for ($j = 0; $j < count($entries_custom_label); $j++) {
                    $entry_custom_label = $entries_custom_label[$j];
                    $value_custom_label = $entry_custom_label->getValues();
                    if ($value_location['sku'] == $value_custom_label['customlabel']) {
                        $value_location['netosku'] = $value_custom_label['sku'];
                        $entry_location->update($value_location);
                    } else {
                        //-------------------------------------------------------------
                        if ($value_location['sku'] == $value_custom_label['barcode']) {
                            $value_location['netosku'] = $value_custom_label['sku'];
                            $entry_location->update($value_location);
                        }
                        //-------------------------------------------------------------                        
                    }//ouer-else
                }//j
            }//i
            /*             * ***************************************************************** */
            $this->Neto_google_location_model->DeleteAll();
            $i = 1;
            $entries_location = $listFeed_location->getEntries();
            
            foreach ($entries_location as $entry_location) {
                $values_location = $entry_location->getValues();
                $values_location['id'] = $i++;
                $object_location = json_decode(json_encode($values_location), FALSE);
                $this->Neto_google_location_model->Create($object_location);
            }
            $this->Neto_google_sku_custom_label_model->DeleteAll();
            $i = 1;
            foreach ($entries_custom_label as $entry_custom_label) {
                $values_custom_label = $entry_custom_label->getValues();
                $values_custom_label['id'] = $i++;
                $object_custom_label = json_decode(json_encode($values_custom_label), FALSE);
                $this->Neto_google_sku_custom_label_model->Create($object_custom_label);
            }
        } catch (Exception $ex) {
            print_r($ex);
        }
    }

    //-----------------------------------------------------
    public $google_client;
    public $accessToken;
    public $serviceRequest;
    public $spreadsheetService;
    public $spreadsheetFeed;
    public $currentSpreadSheet;
    public $worksheetFeed;
    public $currentSpreadSheet2;
    public $worksheetFeed2;

    public function __construct() {
        parent::__construct();
        try {
            $this->google_client = new Google_Client();
            $this->google_client->setClientId($this->google_sheet->ClientID());
            $this->google_client->setClientSecret($this->google_sheet->ClientSecret());
            $this->google_client->setRedirectUri($this->google_sheet->RedirectURI());
            $this->google_client->setScopes(
                    array(
                        'https://www.googleapis.com/auth/userinfo.email',
                        'https://www.googleapis.com/auth/userinfo.profile',
                        'https://spreadsheets.google.com/feeds'));
            $this->google_client->setAccessType("offline");
            $this->google_client->setApprovalPrompt("auto");

            $this->google_plus = new Google_Oauth2Service($this->google_client);
            if (isset($_SESSION['token'])) { // extract token from session and configure client
                $this->google_client->setAccessToken($_SESSION['token']);
            }

            if (!$this->google_client->getAccessToken()) {
                redirect("welcome/index");
            }
            if ($this->google_client->isAccessTokenExpired()) {
                if (isset($_SESSION['refresh_token'])) {
                    $this->google_client->refreshToken($_SESSION['refresh_token']);
                    $_SESSION['token'] = $this->google_client->getAccessToken();
                }
            }
            //$google_token = json_decode($_SESSION['token']);
            //print_r($google_token);
            // $this->google_client->refreshToken($google_token->refresh_token);
            // $_SESSION['token'] = $this->google_client->getAccessToken();
            $this->accessToken = json_decode($this->google_client->getAccessToken());
            $this->serviceRequest = new DefaultServiceRequest($this->accessToken->access_token);
            ServiceRequestFactory::setInstance($this->serviceRequest);
            $this->spreadsheetService = new Google\Spreadsheet\SpreadsheetService();
            $this->spreadsheetFeed = $this->spreadsheetService->getSpreadsheets();
            $this->currentSpreadSheet = $this->spreadsheetFeed->getByTitle("Location-Database - Cortech.xls");
            $this->worksheetFeed = $this->currentSpreadSheet->getWorksheets();
            $this->currentSpreadSheet2 = $this->spreadsheetFeed->getByTitle("SKU / Custom Label / Barcode - Database");
            $this->worksheetFeed2 = $this->currentSpreadSheet2->getWorksheets();
        } catch (Exception $ex) {
            //print_r($ex);
            $this->session->sess_destroy();
            redirect("welcome/index");
        }
    }

}
