<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Welcome extends CI_Controller {

    public $google_client;
    public $google_plus;
    public $white_list = array("info@swampindustries.com", "mansha99@gmail.com");

    public function __construct() {
        parent::__construct();
        try {
            $this->google_client = new Google_Client();
            $this->google_client->setClientId($this->google_sheet->ClientID());
            $this->google_client->setClientSecret($this->google_sheet->ClientSecret());
            $this->google_client->setRedirectUri($this->google_sheet->RedirectURI());
            $this->google_client->setScopes(
                    array(
                        'https://www.googleapis.com/auth/userinfo.email',
                        'https://www.googleapis.com/auth/userinfo.profile',
                        'https://spreadsheets.google.com/feeds'));
            $this->google_client->setAccessType("offline");
            $this->google_client->setApprovalPrompt("auto");

            $this->google_plus = new Google_Oauth2Service($this->google_client);
            if (isset($_SESSION['token'])) { // extract token from session and configure client
                $this->google_client->setAccessToken($_SESSION['token']);
            }
            
        } catch (Exception $ex) {
            print_r($ex);
        }
    }

    public function index() {

        $data = array();
        if ($this->google_client->getAccessToken() && !$this->google_client->isAccessTokenExpired()) {
            redirect("generatedReorder/index");
        } else {
            redirect($this->google_client->createAuthUrl());
        }
        //$data['google_url'] = $this->google_client->createAuthUrl();
        //$this->load->view("layout/front_header");
        //$this->load->view('welcome/index', $data);
        //$this->load->view("layout/front_footer");
    }

    public function dashboard() {
        $data = array();
        if (isset($_GET['code'])) {
            $this->google_client->authenticate();
            $_SESSION['token'] = $this->google_client->getAccessToken();
            $authObj = json_decode($this->google_client->getAccessToken());
            if (isset($authObj->refresh_token)) {
                $_SESSION['refresh_token'] = $authObj->refresh_token;
            }
            $userinfo = $this->google_plus->userinfo;
            $userinfo = $userinfo->get();
            if (in_array($userinfo['email'], $this->white_list)) {
                $_SESSION['userinfo'] = $userinfo;
                redirect("generatedReorder/index");
            } else {
                $this->session->sess_destroy();
                redirect("auth/unAuthorized");
            }
        }
        if (!$this->google_client->getAccessToken()) {

            redirect("welcome/index");
        }
        $this->load->view('layout/front_header', $data);
        $this->load->view('welcome/dashboard', $data);
        $this->load->view('layout/front_footer', $data);
    }

    public function logout() {
        $data = array();
        session_destroy();
        redirect("welcome/logout_message");
    }

    public function logout_message() {
        $this->load->view('layout/front_header', $data);
        $this->load->view('welcome/logout_message', $data);
        $this->load->view('layout/front_footer', $data);
    }

}
