<?php

class MY_Controller extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->setTitle("My Website Name");
        $this->data['view_name'] = $this->view();
        $this->setMessage(null);
    }

    public function setTitle($title) {
        $this->data['title'] = $title;
    }

    public function header() {
        return "layout/front_header";
    }

    public function footer() {
        return "layout/front_footer";
    }

    public function map($key, $value) {
        $this->data[$key] = $value;
    }

    public function view() {
        $ci = & get_instance();
        $controller = $ci->router->fetch_class();
        $action = $ci->router->fetch_method();
        return strtolower($controller) . "/" . $action;
    }

    public function render($view = null, $data = null) {
        $view = $view == null ? $this->view() : $view;
        $data = $data == null ? $this->data : $data;
        $this->load->view($view, $data);
    }

    public function IsPost() {
        $ci = &get_instance();
        return $ci->input->server("REQUEST_METHOD") == "POST";
    }

    //Check if input is empty or not
    public function HasValue($input) {
        return $input != null && isset($input) && trim($input) != "";
    }

    public function Populate(&$object) {
        foreach ($_POST as $key => $value) {
            if (property_exists($object, $key)) {
                $object->$key = htmlspecialchars(trim($_POST[$key]), ENT_QUOTES, 'UTF-8');
            }
        }//
    }

    public function PopulateGet(&$model) {
        foreach ($_GET as $key => $value) {
            if (property_exists($model, $key)) {
                $model->$key = htmlspecialchars(trim($_GET[$key]), ENT_QUOTES, 'UTF-8');
            }
        }//
    }

    public function ValueOrDefaultInteger($value, $default = 0) {
        if ($value != null && isset($value) && ValidationRules::validate_integer($value)) {
            return $value;
        }
        return $default;
    }

    public function ValueOrDefault($value, $default) {
        if ($value != null && isset($value) && trim($value) != "") {
            return $value;
        }
        return $default;
    }

    private $pagesize = 10;

    public function getPagesize() {
        return $this->pagesize;
    }

    public function setPagesize($pagesize) {
        $this->pagesize = $pagesize;
    }

    public function getMessage() {
        return isset($this->data['message']) ? $this->data['message'] : null;
    }

    public function hasMessage() {
        return isset($this->data['message']) ? true : false;
    }

    public function setMessage($message) {
        $this->data['message'] = $message;
    }

    public $data = array();

    public function CurrentUrl() {
        $ci = & get_instance();
        $controller = $ci->router->fetch_class();
        $action = $ci->router->fetch_method();
        return site_url(strtolower($controller) . "/" . $action);
    }

}

?>