<?php

class MY_Model extends CI_Model {

    //####################################################
    public function Prefix($tablename) {
        return $this->db->dbprefix($tablename);
    }

    public function Prefixed($tablename) {
        return $this->db->dbprefix($tablename);
    }

    public function Read() {
        return $this->db->order_by("id", "desc")->get_where($this->Table())->result();
    }

    public function ReadAsc() {
        return $this->db->get_where($this->Table())->result();
    }

    public function ReadWhere($where_array) {
        return $this->db->order_by("id", "desc")->get_where($this->Table(), $where_array)->result();
    }

    public function ReadWhereAsc($where_array) {
        return $this->db->get_where($this->Table(), $where_array)->result();
    }

    public function ReadAssoc($col_name) {
        $outlist = array();
        $list = $this->db->order_by("id", "desc")->get_where($this->Table())->result();
        foreach ($list as $ele) {
            $outlist[$ele->id] = $ele->$col_name;
        }
        return $outlist;
    }

    public function ReadAssocWhere($col_name, $where_array) {
        $outlist = array();
        $list = $this->db->order_by("id", "desc")->get_where($this->Table(), $where_array)->result();
        foreach ($list as $ele) {
            $outlist[$ele->id] = $ele->$col_name;
        }
        return $outlist;
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('id' => $id))->row();
    }

    public function FindCustom($key, $value) {
        return $this->db->get_where($this->Table(), array($key => $value))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        unset($obj_array['id']);
        $this->db->insert($this->Table(), $obj_array);
        $insert_id = $this->db->insert_id();
        $model->id = $insert_id;
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->id;
        $array = (array) $model;
        unset($array['id']);
        $this->db->where('id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteCustom($key, $value) {
        $this->db->where($key, $value); // I change id with book_id
        $this->db->delete($this->Table());
    }

    //table name is same as that of model
    //emp -> emp_model
    public function Table() {
        $s = strtolower(get_class($this));
        return substr($s, 0, strlen($s) - strlen("_model"));
    }

    public function Exists($table, $field, $value) {
        return $this->db->get_where($table, array($field => $value))->row();
    }

    //auto creates an Empty object of Model
    public function Object() {
        $className = get_class($this);
        return new $className;
    }

    //Pppulate 
    public function PopulateFormFromArray($form, $array) {
        $metaobj = new ReflectionObject($form);
        $classname = $metaobj->getName();
        $c = new ReflectionClass($classname);
        foreach ($c->getProperties() as $p) {
            if (isset($array[$p->getName()])) {
                $c->getProperty($p->getName())->setValue($form, htmlspecialchars(trim($array[$p->getName()]), ENT_QUOTES, 'UTF-8'));
            }
        }
    }

    public function PopulateFormFromObject($form, $object) {
        $array = (array) $object;
        $metaobj = new ReflectionObject($form);
        $classname = $metaobj->getName();
        $c = new ReflectionClass($classname);
        foreach ($c->getProperties() as $p) {
            if (isset($array[$p->getName()])) {
                $c->getProperty($p->getName())->setValue($form, htmlspecialchars(trim($array[$p->getName()]), ENT_QUOTES, 'UTF-8'));
            }
        }
    }

}

?>