<?php

class Dearapi {

    public function EndPoint($url) {
        return "https://inventory.dearsystems.com/dearapi/" . $url;
    }

    private function ID() {
        return "498ed6d2-14d5-4f6e-bd33-2acd4440939f";

        //MS
        //return "1cf00c58-b0ed-45f2-ad56-3c8f0fa17f3c";
    }

    private function KEY() {
        return "dc75b9a8-b07c-a573-bbd8-147e6e919908";
        //MS
        //return "14a50669-12f4-af24-529b-a08ef8825c0b";
    }

    public function Headers() {
        return array(
            'api-auth-accountid:' . $this->ID(),
            'api-auth-applicationkey:' . $this->KEY()
        );
    }

    public function HeadersJson($fields_as_array) {
        $json_data = json_encode($fields_as_array);
        return array(
            'api-auth-accountid:' . $this->ID(),
            'api-auth-applicationkey:' . $this->KEY(),
            'Content-Type: application/json',
            'Content-Length: ' . strlen($json_data)
        );
    }

    private function StatusMessage($code) {
        switch ($code) {
            case 200: return "OK,Operation was successful";
                break;

            case 400: return "Bad Request,The request was not in a correct form, or the posted data failed a validation test. Check the error returned to see what was wrong with the request.";
                break;

            case 403: return "Forbidden ,Method authentication failed";
                break;

            case 404: return " Not found,Endpoint does not exist (eg using /Customer instead of /Customers)";
                break;

            case 405: return " Not allowed,The method used is not allowed (eg PUT, DELETE)";
                break;

            case 500: return " Internal Server Error,The object passed to the API could not be parsed or some unexpected error occurred in DEAR while processing API request";
                break;

            case 503: return " Service Unavailable ,You reached 60 calls per minute API limit";
        }
    }

}
