<?php

class Generate_order_display_model extends MY_Model {

    public $cols = array(
        "supplier",
        "productstoreorder",
        "reordervalue",
        "suppliercode",
        "startordernumber",
        "suppliertype",
        "port",
        "supleadtime",
        "supdaystostock",
        "createpo"
    );

    public function ReadAssocBySupplier() {
        $list = $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->supplier] = $value;
        }
        return $outlist;
    }

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function FindBysupplier($supplier) {
        return $this->db->get_where($this->Table(), array('supplier' => $supplier))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        $out_array = array();
        foreach ($obj_array as $col_name => $col_value) {
            if ($col_name == "sup.leadtime") {
                $out_array["supleadtime"] = $col_value;
            }else if ($col_name == "sup.daystostock") {
                $out_array["supdaystostock"] = $col_value;
            } else {
                $out_array[$col_name] = $col_value;
            }
        }
        $this->db->insert($this->Table(), $out_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteAll() {
        $this->db->where('_id !=', 0);
        $this->db->delete($this->Table());
    }

}
