<?php

class Generated_reorder_model extends MY_Model {

    public $_id;
    public $_dt;
    public $ID; //from sale_line ProductID
    public $SKU; //from sale_line
    public $LastSuppliedBy; //manual_product_data
    public $DaysInStock; //formula,daysInStock
    public $Sales; //formula,calculateSales
    public $Velocity; //formula,
    public $OnHand; //Product_availability
    public $Allocated; //Product_availability
    public $OnOrder; //Product_availability
    public $MinimumBeforeReorder; //Product_model
    public $ReorderQuantity; //Product_model
    public $NoStockinXDays; //formula,
    public $MOQ; //Product,AdditionalAttribute1
    public $PcsPerCarton; //Product,AdditionalAttribute2
    public $LeadTime; //Product,AdditionalAttribute3
    public $DaystoStock; //Product,AdditionalAttribute4
    public $ReorderinXDays; //formula
    public $ToOrder; //formula
    public $AmounttoOrder; //depends on pcs per carton
    public $ReOrderDue; //formula
    public $CustomOrderAmount; //text box
    public $ReOrder; //checkbox
    public $AutoReOrder; //Leave Now
    public $_supplier_code;
    public $_supplier_type;
    public $_supplier_port;
    public $_custom_checkbox;
    public $_ordered;
    public $_uncheck;

    //which column ?
    public function SetAllUnChecktoFalse() {
        $this->db->query("update gs_generated_reorder set _uncheck ='false' ");
    }

    public function GetSupplierName($s) {
        $start_index = strpos($s, "(");
        $end_index = strpos($s, ")");
        return trim(substr($s, 0, $start_index - 1));
    }

    public function GetSupplierCode($s) {
        $start_index = strpos($s, "(");
        $end_index = strpos($s, ")");
        return trim(substr($s, $start_index + 1, $end_index - ($start_index + 1)));
    }

    public function Cols() {
        $cols = array();
        foreach (get_object_vars($this) as $key => $value) {
            if (substr($key, 0, 1) == "_") {
                continue;
            }
            $cols[] = $key;
        }
        return $cols;
    }

    public function ReadLatest() {
        return $this->db->query("select * from gs_generated_reorder where _dt = ( select max(_dt) from gs_generated_reorder ) ")->result();
    }

    public function ClearAllOrders($SKUs) {
        $parts = explode(",", $SKUs);
        $data = array(
            'ReOrder' => 'no',
            '_ordered' => 'yes'
        );
        $this->db->where_in('SKU', $parts);

        //  $this->db->update($this->Table(), $data);
        $this->db->delete($this->Table());
    }

    public function ReadLatestMultiple($IDs) {
        $parts = explode(",", $IDs);
        for ($i = 0; $i < count($parts); $i++) {
            $parts[$i] = "'" . $parts[$i] . "'";
        }
        $IDs = implode(",", $parts);
        //   echo "select * from gs_generated_reorder where ID in ($IDs) and  _dt = ( select max(_dt) from gs_generated_reorder ) ";
        return $this->db->query("select * from gs_generated_reorder where ID in ($IDs) and  _dt = ( select max(_dt) from gs_generated_reorder ) ")->result();
    }

    public function ReadLatestMultipleGroupBySupplier($IDs) {
        $parts = explode(",", $IDs);
        for ($i = 0; $i < count($parts); $i++) {
            $parts[$i] = "'" . $parts[$i] . "'";
        }
        $IDs = implode(",", $parts);
        //   echo "select * from gs_generated_reorder where ID in ($IDs) and  _dt = ( select max(_dt) from gs_generated_reorder ) ";
        $list = $this->db->query("select * from gs_generated_reorder where ID in ($IDs) and  _dt = ( select max(_dt) from gs_generated_reorder ) ")->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->LastSuppliedBy][] = $value;
        }
        return $outlist;
    }

    public function ReadAssocByLastSuppliedByAndSku() {
        $list = $this->db->order_by("_id", "desc")->get_where($this->Table(), array("ReOrder" => "yes"))->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->LastSuppliedBy][$value->SKU] = $value;
        }
        return $outlist;
    }

    public function ReadAssocBySku() {
        $list = $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->SKU] = $value;
        }
        return $outlist;
    }

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function ReadForDate($dt) {
        return $this->db->order_by("_id", "desc")->get_where($this->Table(), array("dt" => $dt))->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function FindByID($ID) {
        return $this->db->get_where($this->Table(), array('ID' => $ID))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        unset($obj_array['_id']);
        $this->db->insert($this->Table(), $obj_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function UpdateCustomOrderAmount($CustomOrderAmount, $ID) {
        $array = array(
            "_custom_checkbox" => "yes",
            "CustomOrderAmount" => $CustomOrderAmount);
        $this->db->where('ID', $ID);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function UpdateCustomOrderAmountNo($CustomOrderAmount, $ID) {
        //$array = array(
        //  "_custom_checkbox" => "no",
        //"CustomOrderAmount" => $CustomOrderAmount);
        $array = array(
            "_custom_checkbox" => "no");
        $this->db->where('ID', $ID);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function updateConditional($IDs) {
        $table_name = $this->db->dbprefix("generated_reorder");
        $q = "UPDATE {$table_name} ";
        $q = $q . " SET ReorderQuantity = (case when _custom_checkbox = 'yes' then CustomOrderAmount ";
        $q = $q . " when _custom_checkbox != 'yes' then AmounttoOrder end ) ";
        $q = $q . " WHERE ID in ($IDs)";
        $this->db->query($q);
    }

    public function updateConditionalSingle($ID) {
        $table_name = $this->db->dbprefix("generated_reorder");
        $q = "UPDATE {$table_name} ";
        $q = $q . " SET ReorderQuantity = (case when _custom_checkbox = 'yes' then CustomOrderAmount ";
        $q = $q . " when _custom_checkbox != 'yes' then AmounttoOrder end ) ";
        $q = $q . " WHERE ID = '$ID'";
        $this->db->query($q);
    }

    public function ResetReorder($IDs) {
        $data = array(
            'ReOrder' => 'no'
        );
        $this->db->where('_id!=', '0');
        $this->db->update($this->Table(), $data);
        $data = array(
            'ReOrder' => 'yes'
        );

        $this->db->where_in("ID", $IDs);
        $this->db->update($this->Table(), $data);
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteForDate($dt) {
        $this->db->where('_dt', $dt);
        $this->db->delete($this->Table());
    }

    public function DeleteMultipleForSaleID($sale_ID) {
        $this->db->where('sale_ID', $sale_ID);
        $this->db->delete($this->Table());
    }

    public function DeleteOld() {
        $q1 = $this->db->query("select max(_dt) dt from gs_generated_reorder ")->row();
        if ($q1) {
            $dt = $q1->dt;
            return $this->db->query("delete  from gs_generated_reorder where _dt != '{$dt}' ");
        }
    }

}
