<?php

class Manual_product_data_model extends MY_Model {

    public $cols = array(
        "sku",
        "lastsuppliedby",
        "supplierproductcode",
        "supplierproductname",
        "supplierfixedprice",
        "moq",
        "pcspercarton",
        "leadtime",
        "daystostock",
        "notesproduct",
        "notespackaging",
        "notescartons",
        "notesmarks",
        "notesqc",
        "notesbrand",
        "supplier",
        "cartonweight",
        "cartonheight",
        "cartonwidth",
        "cartondepth",
        "daysinstock",
        "sales",
        "manualminimumbeforereorder"
    );

    public function getSupplierCode($lastsuppliedby) {

        $i1 = strpos($lastsuppliedby, "(");
        $i2 = strpos($lastsuppliedby, ")");

        return trim(substr($lastsuppliedby, $i1 + 1, $i2 - $i1 - 1));
    }

    public function ReadAssocBySku() {
        $list= $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
        $outlist=array();
        foreach ($list as $value){
            $outlist[$value->sku]=$value;
        }
        return $outlist;
    }

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function FindBysku($sku) {
        return $this->db->get_where($this->Table(), array('sku' => $sku))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        $out_array = array();
        foreach ($obj_array as $col_name => $col_value) {
            if (in_array($col_name, $this->cols) || $col_name == "_username") {
                $out_array[$col_name] = $col_value;
            }
        }
        $this->db->insert($this->Table(), $out_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteAll() {
        $this->db->where('_id !=', 0);
        $this->db->delete($this->Table());
    }

    public function DeleteMultipleBySKU($values) {
        $this->db->where_in('sku', $values);
        $this->db->delete($this->Table());
    }

}
