<?php

class Product_availability_model extends MY_Model {

    public $_id;
    public $_dt;
    public $ID;
    public $SKU;
    public $Name;
    public $Barcode;
    public $Location;
    public $Bin;
    public $Batch;
    public $ExpiryDate;
    public $OnHand;
    public $Allocated;
    public $OnOrder;
    public $StockOnHand;

    public function Cols() {
        $cols = array();
        foreach (get_object_vars($this) as $key => $value) {
            $cols[] = $key;
        }
        return $cols;
    }

    public function ReadLatest() {
        return $this->db->query("select * from gs_product_availability where _dt = ( select max(_dt) from gs_product_availability ) ")->result();
    }

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function ReadForDate($dt) {
        return $this->db->order_by("_id", "desc")->get_where($this->Table(), array("_dt" => $dt))->result();
    }

    public function ReadForID($ID) {
        return $this->db->order_by("_dt", "desc")->get_where($this->Table(), array("ID" => $ID))->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        unset($obj_array['_id']);
        $this->db->insert($this->Table(), $obj_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id);
        $this->db->delete($this->Table());
    }

    public function DeleteForDate($dt) {
        $this->db->where("_dt", $dt);
        $this->db->delete($this->Table());
    }

}
