<?php

class Reorder_display_model extends MY_Model {

    public $cols = array(
        "id",
        "sku",
        "lastsuppliedby",
        "daysinstock",
        "sales",
        "velocity",
        "onhand",
        "allocated",
        "onorder",
        "minimumbeforereorder",
        "reorderquantity",
        "nostockinxdays",
        "moq",
        "pcspercarton",
        "leadtime",
        "daystostock",
        "reorderinxdays",
        "toorder",
        "amounttoorder",
        "reorderdue",
        "customorderamount",
        "reorder",
        "autoreorder",
    );

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }
    public function FindForSKU($sku) {
        return $this->db->get_where($this->Table(), array('sku' => $sku))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        $out_array = array();
        foreach ($obj_array as $col_name => $col_value) {
            if (in_array($col_name, $this->cols) || $col_name == "_username") {
                $out_array[$col_name] = $col_value;
            }
        }
        $this->db->insert($this->Table(), $out_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteAll() {
        $this->db->where('_id !=', 0);
        $this->db->delete($this->Table());
    }

}
