<?php

class Sale_model extends MY_Model {

    public $_id; // int;// primary key auto_increment,
    public $ID; //varchar(100),
    public $Customer; //varchar(100),
    public $Contact; //varchar(100),
    public $Phone; //varchar(100),
    public $Email; //varchar(100),
    public $DefaultAccount; //varchar(100),
    public $SkipQuote; //varchar(100),
    public $BillingAddress_DisplayAddressLine1; //varchar(100),
    public $BillingAddress_DisplayAddressLine2; //varchar(100),
    public $BillingAddress_Line1; //varchar(100),
    public $BillingAddress_Line2; //varchar(100),
    public $BillingAddress_City; //varchar(100),
    public $BillingAddress_State; //varchar(100),
    public $BillingAddress_Postcode; //varchar(100),
    public $BillingAddress_Country; //varchar(100),
    public $BaseCurrency; //varchar(100),
    public $CustomerCurrency; //varchar(100),
    public $TaxRule; //varchar(100),
    public $TaxCalculation; //varchar(100),
    public $Terms; //varchar(100),
    public $PriceTier; //varchar(100),
    public $ShipBy; //varchar(100),
    public $Location; //varchar(100),
    public $LastModifiedOn; //varchar(100),
    public $Note; //varchar(1024),
    public $CustomerReference; //varchar(100),
    public $COGSAmount; //varchar(100),
    public $Status; //varchar(100),
    public $CurrencyRate; //varchar(100),
    public $SalesRepresentative; //varchar(100),
    public $ServiceOnly; //varchar(100),
    public $_status; //varchar(255)
    public $_synced; //varchar(255)
    public $_syncdate; //varchar(255)

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function FindByID($ID) {
        return $this->db->get_where($this->Table(), array('ID' => $ID))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        unset($obj_array['_id']);
        $this->db->insert($this->Table(), $obj_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteForID($id) {
        $this->db->where('ID', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }
   public function DeleteForDate($_syncdate) {
        $this->db->where('_syncdate', $_syncdate); // I change id with book_id
        $this->db->delete($this->Table());
    }
    public function DeleteForDateAndID($_syncdate,$ID) {
        $this->db->where('_syncdate', $_syncdate);
        $this->db->where('ID', $ID);        
        $this->db->delete($this->Table());
    }
    

    public function DeleteAll() {
        $this->db->where('_id !=', 0);
        $this->db->delete($this->Table());
    }

    public function DeleteMultipleByID($values) {
        $this->db->where_in('ID', $values);
        $this->db->delete($this->Table());
    }

    public function Populate($object) {
        $this->ID = $object->ID;
        $this->Customer = $object->Customer;
        $this->Contact = $object->Contact;
        $this->Phone = $object->Phone;
        $this->Email = $object->Email;
        $this->DefaultAccount = $object->DefaultAccount;
        $this->SkipQuote = $object->SkipQuote;
        $this->BillingAddress_DisplayAddressLine1 = $object->BillingAddress->DisplayAddressLine1;
        $this->BillingAddress_DisplayAddressLine2 = $object->BillingAddress->DisplayAddressLine2;
        $this->BillingAddress_Line1 = $object->BillingAddress->Line1;
        $this->BillingAddress_Line2 = $object->BillingAddress->Line2;
        $this->BillingAddress_City = $object->BillingAddress->City;
        $this->BillingAddress_State = $object->BillingAddress->State;
        $this->BillingAddress_Postcode = $object->BillingAddress->Postcode;
        $this->BillingAddress_Country = $object->BillingAddress->Country;
        $this->BaseCurrency = $object->BaseCurrency;
        $this->CustomerCurrency = $object->CustomerCurrency;
        $this->TaxRule = $object->TaxRule;
        $this->TaxCalculation = $object->TaxCalculation;
        $this->Terms = $object->Terms;
        $this->PriceTier = $object->PriceTier;
        $this->ShipBy = $object->ShipBy;
        $this->Location = $object->Location;
        $this->LastModifiedOn = $object->LastModifiedOn;
        $this->Note = $object->Note;
        $this->CustomerReference = $object->CustomerReference;
        $this->COGSAmount = $object->COGSAmount;
        $this->Status = $object->Status;
        $this->CurrencyRate = $object->CurrencyRate;
        $this->SalesRepresentative = $object->SalesRepresentative;
        $this->ServiceOnly = $object->ServiceOnly;
        $this->_status = "active";
        $this->_synced = "yes";
        $this->_syncdate = date("Y-m-d");
    }

}
