<?php

class Setting_field_model extends MY_Model {

    public $_id; // int primary key auto_increment,
    public $table_name; // varchar(60),
    public $field_name; // varchar(60),
    public $status; // varchar(10)

    public function Read() {
        return $this->db->order_by("_id", "desc")->get_where($this->Table())->result();
    }

    public function ReadTableNames() {
        $list = $this->db->query("select distinct(table_name) as table_name from gs_setting_field order by  table_name")->result();

        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->table_name] = $value->table_name;
        }
        return $outlist;
    }

    public function ReadForTable($table_name) {
        $exclude_list = array(
            "_dt",
            "_id",
            "_supplier_code",
            "_supplier_port",
            "_ordered",
            "_custom_checkbox",
            "_supplier_type",
            "CustomOrderAmount");

        $list = $this->db->get_where($this->Table(), array("table_name" => $table_name))->result();
        $outlist = array();
        foreach ($list as $value) {
            if ($table_name == "gs_generated_reorder" || $table_name == "generated_reorder") {
                if (in_array($value->field_name, $exclude_list)) {
                    continue;
                }
            }
            $outlist[$value->field_name] = $value;
        }
        return $outlist;
    }

    public function ReadVisibleFieldForTable($table_name) {
        $list = $this->db->get_where($this->Table(), array("status" => "yes", "table_name" => $table_name))->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[] = $value->field_name;
        }
        return $outlist;
    }

    public function ReadVisibleFieldForTableAssoc($table_name) {
        $list = $this->db->get_where($this->Table(), array("status" => "yes", "table_name" => $table_name))->result();
        $outlist = array();
        foreach ($list as $value) {
            $outlist[$value->field_name] = $value->field_name;
        }
        return $outlist;
    }

    public function Find($id) {
        return $this->db->get_where($this->Table(), array('_id' => $id))->row();
    }

    public function Exist($table_name, $field_name) {
        return $this->db->get_where($this->Table(), array('table_name' => $table_name, "field_name" => $field_name))->row();
    }

    public function Create(&$model) {
        $obj_array = (array) $model;
        unset($obj_array['_id']);
        $this->db->insert($this->Table(), $obj_array);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function Update(&$model) {
        $id = $model->_id;
        $array = (array) $model;
        unset($array['_id']);
        $this->db->where('_id', $id);
        $this->db->update($this->Table(), $array);
        return true;
    }

    public function Delete($id) {
        $this->db->where('_id', $id); // I change id with book_id
        $this->db->delete($this->Table());
    }

    public function DeleteAll() {
        $this->db->where('_id!=', 0); // I change id with book_id
        $this->db->delete($this->Table());
    }

}
